=== modified file 'plugin/rabbitmq/rabbitmq_handler.cc'
--- plugin/rabbitmq/rabbitmq_handler.cc	2011-03-30 19:50:29 +0000
+++ plugin/rabbitmq/rabbitmq_handler.cc	2011-03-31 13:02:08 +0000
@@ -50,11 +50,13 @@
     exchange(rabbitMQExchange), 
     routingKey(rabbitMQRoutingKey)
 {
+  pthread_mutex_init(&publishLock, NULL);
   connect();
 }
 
 RabbitMQHandler::~RabbitMQHandler()
 {
+  pthread_mutex_destroy(&publishLock);
   disconnect();
 }
 
@@ -62,6 +64,7 @@
                               const int length)
 throw(rabbitmq_handler_exception)
 {
+  pthread_mutex_lock(&publishLock);
   amqp_bytes_t b;
   b.bytes= message;
   b.len= length;
@@ -75,8 +78,10 @@
                          NULL,
                          b) < 0)
   {
+    pthread_mutex_unlock(&publishLock);
     throw rabbitmq_handler_exception("Could not publish message");
   }
+  pthread_mutex_unlock(&publishLock);
 
 }
 

=== modified file 'plugin/rabbitmq/rabbitmq_handler.h'
--- plugin/rabbitmq/rabbitmq_handler.h	2011-03-30 19:50:29 +0000
+++ plugin/rabbitmq/rabbitmq_handler.h	2011-03-31 13:02:08 +0000
@@ -68,6 +68,7 @@
   const std::string &virtualhost;
   const std::string &exchange;
   const std::string &routingKey;
+  pthread_mutex_t publishLock;
 public:
   /**
    * @brief

